OGRE-Next: Ogre::v1::ManualObject::ManualObjectSection Class Reference

| OGRE-Next 3.0.0 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Public Member Functions | List of all members
Ogre::v1::ManualObject::ManualObjectSection Class Reference

Built, renderable section of geometry. More...

`#include <OgreManualObject.h>`

Inheritance diagram for Ogre::v1::ManualObject::ManualObjectSection:
[legend]

## Public Member Functions
| ManualObjectSection (ManualObject *parent, const String &materialName, OperationType opType, const String &groupName=ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME)
| ~ManualObjectSection () override
bool | get32BitIndices () const
| Get whether we need 32-bit indices.
const LightList & | getLights () const override
| Gets a list of lights, ordered relative to how close they are to this renderable.
const MaterialPtr & | getMaterial () const
| Retrieves the material this renderable object uses.
const String & | getMaterialGroup () const
| Retrieve the material group in use.
const String & | getMaterialName () const
| Retrieve the material name in use.
RenderOperation * | getRenderOperation ()
| Retrieve render operation for manipulation.
void | getRenderOperation (RenderOperation &op, bool casterPass) override
| Gets the render operation required to send this object to the frame buffer.
Real | getSquaredViewDepth (const Ogre::Camera *) const
void | getWorldTransforms (Matrix4 *xform) const override
| Gets the world transform matrix / matrices for this renderable object.
void | set32BitIndices (bool n32)
| Set whether we need 32-bit indices.
void | setMaterialName (const String &name, const String &groupName=ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME)
| update the material name in use
Public Member Functions inherited from Ogre::Renderable
| Renderable ()
virtual | ~Renderable ()
| Virtual destructor needed as class has virtual methods.
virtual void | _setHlmsHashes (uint32 hash, uint32 casterHash)
| Manually sets the hlms hashes. Don't call this directly.
virtual void | _setNullDatablock ()
| Sets the datablock to a null pointer.
virtual void | _updateCustomGpuParameter (const GpuProgramParameters_AutoConstantEntry &constantEntry, GpuProgramParameters *params) const
| Update a custom GpuProgramParameters constant which is derived from information only this Renderable knows.
void | addPoseWeight (size_t index, float w)
virtual bool | getCastsShadows () const
| Method which reports whether this renderable would normally cast a shadow.
uint8 | getCurrentMaterialLod () const
const Vector4 & | getCustomParameter (size_t index) const
| Gets the custom value associated with this Renderable at the given index.
const CustomParameterMap & | getCustomParameters () const
HlmsDatablock * | getDatablock () const
const String & | getDatablockOrMaterialName () const
uint32 | getHlmsCasterHash () const
uint32 | getHlmsHash () const
MaterialPtr | getMaterial () const
| Retrieves the material this renderable object uses.
unsigned short | getNumPoses () const
virtual unsigned short | getNumWorldTransforms () const
| Returns the number of world transform matrices this renderable requires.
virtual bool | getPolygonModeOverrideable () const
| Gets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.
bool | getPoseHalfPrecision () const
bool | getPoseNormals () const
TexBufferPacked * | getPoseTexBuffer () const
float | getPoseWeight (size_t index) const
float * | getPoseWeights () const
uint8 | getRenderQueueSubGroup () const
bool | getUseIdentityProjection () const
| Returns whether or not to use an 'identity' projection.
bool | getUseIdentityView () const
| Returns whether or not to use an 'identity' view.
virtual bool | getUseIdentityViewProjMatrixIsDynamic () const
| Returns whether the Hlms implementation should evaluate getUseIdentityProjection per object at runtime, or if it can assume the Renderable will remain with the same setting until the datablock is flushed (performance optimization)
virtual bool | getUseIdentityWorldMatrix () const
| Returns whether the world matrix is an identity matrix.
virtual OGRE_DEPRECATED const Any & | getUserAny () const
UserObjectBindings & | getUserObjectBindings ()
| Return an instance of user objects binding associated with this class.
const UserObjectBindings & | getUserObjectBindings () const
| Return an instance of user objects binding associated with this class.
const VertexArrayObjectArray & | getVaos (VertexPass vertexPass) const
bool | hasCustomParameter (size_t index) const
| Checks whether a custom value is associated with this Renderable at the given index.
bool | hasSkeletonAnimation () const
virtual void | postRender (SceneManager *sm, RenderSystem *rsys)
| Called immediately after the Renderable has been rendered.
virtual bool | preRender (SceneManager *sm, RenderSystem *rsys)
| Called just prior to the Renderable being rendered.
void | removeCustomParameter (size_t index)
| Removes a custom value which is associated with this Renderable at the given index.
void | setCustomParameter (size_t index, const Vector4 &value)
| Sets a custom parameter for this Renderable, which may be used to drive calculations for this specific Renderable, like GPU program parameters.
virtual void | setDatablock (HlmsDatablock *datablock)
| Assigns a datablock (i.e. HLMS Material) to this renderable.
void | setDatablock (IdString datablockName)
| Assigns a datablock (i.e.
void | setDatablockOrMaterialName (String materialName, String groupName)
| First tries to see if an HLMS datablock exist with the given name, if not, tries to search among low level materials.
virtual void | setMaterial (const MaterialPtr &material)
| Sets the given material. Overrides HLMS materials.
void | setMaterialName (const String &name, const String &groupName)
| Sets the name of the Material to be used. Prefer using HLMS.
virtual void | setPolygonModeOverrideable (bool override)
| Sets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.
void | setPoseWeight (size_t index, float w)
void | setRenderQueueSubGroup (uint8 subGroup)
| Sets the render queue sub group.
void | setUseIdentityProjection (bool useIdentityProjection)
| Sets whether or not to use an 'identity' projection.
void | setUseIdentityView (bool useIdentityView)
| Sets whether or not to use an 'identity' view.
virtual OGRE_DEPRECATED void | setUserAny (const Any &anything)

## Additional Inherited Members
Public Types inherited from Ogre::Renderable
typedef map< size_t, Vector4 >::type | CustomParameterMap
Static Public Member Functions inherited from Ogre::Renderable
static uint8 | getDefaultRenderQueueSubGroup ()
static void | setDefaultRenderQueueSubGroup (uint8 subGroup)
| Sets the default render queue sub group for all future Renderable instances.
Public Attributes inherited from Ogre::Renderable
uint8 | mCustomParameter
uint32 | mHlmsGlobalIndex
| Index in the vector holding this Rendrable reference in the HLMS datablock.
bool | mRenderableVisible
| Control visibility at Renderable (e.g.

## Detailed Description

Built, renderable section of geometry.

## Constructor & Destructor Documentation

## ◆ ManualObjectSection()

Ogre::v1::ManualObject::ManualObjectSection::ManualObjectSection | ( | ManualObject * | parent,
|  | const String & | materialName,
|  | OperationType | opType,
|  | const String & | groupName = ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME )

References Ogre::v1::ManualObject::ManualObject(), and Ogre::ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME.

## ◆ ~ManualObjectSection()

Ogre::v1::ManualObject::ManualObjectSection::~ManualObjectSection | ( |  | ) |
| override

## Member Function Documentation

## ◆ get32BitIndices()

bool Ogre::v1::ManualObject::ManualObjectSection::get32BitIndices | ( |  | ) | const
| inline

Get whether we need 32-bit indices.

## ◆ getLights()

const LightList & Ogre::v1::ManualObject::ManualObjectSection::getLights | ( |  | ) | const
| overridevirtual

Gets a list of lights, ordered relative to how close they are to this renderable.

Remarks
  Directional lights, which have no position, will always be first on this list.

Implements Ogre::Renderable.

## ◆ getMaterial()

const MaterialPtr & Ogre::v1::ManualObject::ManualObjectSection::getMaterial | ( |  | ) | const

Retrieves the material this renderable object uses.

It may be null if it's using the HLMS.

See also
  getDatablock

## ◆ getMaterialGroup()

const String & Ogre::v1::ManualObject::ManualObjectSection::getMaterialGroup | ( |  | ) | const
| inline

Retrieve the material group in use.

## ◆ getMaterialName()

const String & Ogre::v1::ManualObject::ManualObjectSection::getMaterialName | ( |  | ) | const
| inline

Retrieve the material name in use.

## ◆ getRenderOperation() [1/2]

RenderOperation * Ogre::v1::ManualObject::ManualObjectSection::getRenderOperation | ( |  | ) |

Retrieve render operation for manipulation.

## ◆ getRenderOperation() [2/2]

void Ogre::v1::ManualObject::ManualObjectSection::getRenderOperation | ( | RenderOperation & | op,
|  | bool | casterPass )
| overridevirtual

Gets the render operation required to send this object to the frame buffer.

Implements Ogre::Renderable.

## ◆ getSquaredViewDepth()

Real Ogre::v1::ManualObject::ManualObjectSection::getSquaredViewDepth | ( | const Ogre::Camera * |  | ) | const

## ◆ getWorldTransforms()

void Ogre::v1::ManualObject::ManualObjectSection::getWorldTransforms | ( | Matrix4 * | xform | ) | const
| overridevirtual

Gets the world transform matrix / matrices for this renderable object.

Remarks
  If the object has any derived transforms, these are expected to be up to date as long as all the SceneNode structures have been updated before this is called.

  This method will populate transform with 1 matrix if it does not use vertex blending. If it does use vertex blending it will fill the passed in pointer with an array of matrices, the length being the value returned from getNumWorldTransforms.

Note
  Internal Ogre never supports non-affine matrix for world transform matrix/matrices, the behavior is undefined if returns non-affine matrix here.

See also
  Matrix4::isAffine.

Implements Ogre::Renderable.

## ◆ set32BitIndices()

void Ogre::v1::ManualObject::ManualObjectSection::set32BitIndices | ( | bool | n32 | ) |
| inline

Set whether we need 32-bit indices.

## ◆ setMaterialName()

void Ogre::v1::ManualObject::ManualObjectSection::setMaterialName | ( | const String & | name,
|  | const String & | groupName = ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME )

update the material name in use

References Ogre::ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME.

The documentation for this class was generated from the following file:

- OgreManualObject.h